/*
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2009 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://jersey.dev.java.net/CDDL+GPL.html
 * or jersey/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at jersey/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 *
 * Contributor(s):
 *
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */
package com.mycompany.JSONTrials.providers;

import com.mycompany.JSONTrials.jaxb.types.ContactType;
import com.mycompany.JSONTrials.jaxb.types.CountryType;
import com.mycompany.JSONTrials.jaxb.types.CustomerOrderType;
import com.mycompany.JSONTrials.jaxb.types.CustomerType;
import com.mycompany.JSONTrials.jaxb.types.DeliveryAddressType;
import com.mycompany.JSONTrials.jaxb.types.DeliveryType;
import com.mycompany.JSONTrials.jaxb.types.ItemType;
import com.mycompany.JSONTrials.jaxb.types.LineItemType;
import com.mycompany.JSONTrials.jaxb.types.OrderItemType;
import com.mycompany.JSONTrials.jaxb.types.OrderLineType;
import com.mycompany.JSONTrials.jaxb.types.OrderType;
import com.mycompany.JSONTrials.jaxb.types.OriginatorCustomerPartyType;
import com.mycompany.JSONTrials.jaxb.types.PartyNameType;
import com.mycompany.JSONTrials.jaxb.types.PartyType;
import com.mycompany.JSONTrials.jaxb.types.PostalAddressType;
import com.mycompany.JSONTrials.jaxb.types.PriceType;
import com.sun.jersey.api.json.JSONConfiguration;
import com.sun.jersey.api.json.JSONJAXBContext;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import javax.ws.rs.ext.ContextResolver;
import javax.ws.rs.ext.Provider;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;

/**
 *
 * @author naresh
 */
@Provider
public class JAXBContextResolver  implements ContextResolver<JAXBContext> {
        private JAXBContext context;
        private final Class[] cTypes = {
                                        ContactType.class,
                                        CountryType.class,
                                        CustomerOrderType.class,
                                        CustomerType.class,
                                        DeliveryAddressType.class,
                                        DeliveryType.class,
                                        ItemType.class,
                                        LineItemType.class,
                                        OrderItemType.class,
                                        OrderLineType.class,
                                        OrderType.class,
                                        OriginatorCustomerPartyType.class,
                                        PartyNameType.class,
                                        PartyType.class,
                                        PostalAddressType.class,
                                        PriceType.class
                                       };
        private final Set<Class> types;
        public JAXBContextResolver() {
            /*
            Map<String, String> ns2json = new HashMap<String, String>();
            ns2json.put("urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2","cac2");
            ns2json.put("urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2","cbc2");
            ns2json.put("urn:oasis:names:specification:ubl:schema:xsd:Order-2","o2");
             */
            try {
                this.types = new HashSet<Class>(Arrays.asList(cTypes));
                //this.context = new JSONJAXBContext(JSONConfiguration.mapped().xml2JsonNs(ns2json).rootUnwrapping(false).build(), cTypes);
                this.context = new JSONJAXBContext(JSONConfiguration.natural().rootUnwrapping(false).build(), cTypes);
            } catch (JAXBException ex) {
                throw new RuntimeException(ex);
            }
        }

        public JAXBContext getContext(Class<?> c) {
            return types.contains(c) ? context : null;
        }
    }
